#ifndef BOARD_VIEW_H
#define BOARD_VIEW_H 1

#include "local_config.h"

#define Object X11Object        /* To avoid problems with Objective C */

#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Form.h>
#include <Xm/ToggleB.h>
#include <Xm/DrawingA.h>
#include <Xm/Frame.h>
#include <Xm/AtomMgr.h>
#include <Xm/Protocols.h>
/* #include <Xm/PushBG.h> */
#include <Xm/CascadeB.h>
#include <Xm/DialogS.h>
#include <Xm/TextF.h>
#include <Xm/Text.h>

#undef Object

#include <objc/objc.h>
#include "objc/Object.h"

#include "pixmap_reader.h"
#include "messages.h"
#include "enums.h"

void wm_delete_window(Widget w, XtPointer client_data, XtPointer callData);
void ResizeEvent (Widget w, XtPointer client_data, XtPointer call_data);
void InputEvent (Widget w, XtPointer client_data, XtPointer call_data);
void ExposeEvent (Widget w, XtPointer client_data, XtPointer call_data);
void Left_Fire (Widget w, XtPointer client_data, XtPointer call_data);
void Left_Pass (Widget w, XtPointer client_data, XtPointer call_data);
void Right_Fire (Widget w, XtPointer client_data, XtPointer call_data);
void Right_Pass (Widget w, XtPointer client_data, XtPointer call_data);
/*void Unfire (Widget w, XtPointer client_data, XtPointer call_data);*/
void activate_Unfire (Widget w, XtPointer client_data, XtPointer call_data);
void disarm_Unfire (Widget w, XtPointer client_data, XtPointer call_data);
KeySym Key2Keysym (XKeyEvent *keyevent);
void CopyAsColor (Display *display,
		  Pixmap src, Drawable dest,
		  GC gc,
		  int src_x, int src_y,
		  unsigned int width, unsigned int height,
		  int dest_x, int dest_y,
		  unsigned long *bg_pixel,
		  unsigned long *fg_pixel);


#define D_color 1
#define D_highlighted 2
#define D_frozen 4
#define D_lazed 8


@interface Board_View : Object
{
    XtAppContext app_context;
    Widget shell;
    Widget form;
    Widget frame;
    Widget draw;
    Atom WM_DELETE_WINDOW;

    Widget left_row_column;
    Widget left_fire;
    Widget left_pass;
    Widget right_row_column;
    Widget right_fire;
    Widget right_pass;

    
    Display *display;
    Visual *visual;
    Window window;
    Screen *screen;
    Colormap cmap;
    GC gc;
    int depth;

    XColor blue;
    XColor grey;
    XColor grey40;
    XColor white;
    XColor black;
    
    Pixmap pieces_pixmap;
    Pixmap back_store;

    id *lb;
    Player_Color board_color;
}

- init_board : (int) argc
	     : (char **) argv
	     : (XtAppContext) ac
	     : (char *) display_name
	     : (Player_Color) set_board_color;
- (void) delete_self;
- (void) set_logical_board : (id *) set_lb;
- (void) process_message : (char *) message : (int) len;
/* - (void) clear_board; */
- (int) dirs_look_the_same : (int) piece : (int) dir1 : (int) dir2;

- (void) place_beam : (int) x : (int) y : (int) direction;
- (void) remove_beam;

@end

extern void _XEditResCheckMessages();

#endif /* BOARD_VIEW_H */
